#include "config.h"
#include "lcd.h"
#include <util/delay.h>

U8 swap(U8 x) {	

return ((x >> 4) | (x << 4)); 

}

void Port_init_lcd(void)
{


DDRA=0xFF;
PORTA&=0xF0;

DDRF|=1<<DDF4;
DDRF|=1<<DDF5;
DDRF|=1<<DDF6;
PORTD&=10001111;
}

void write_lcd_once(U8 n)
{
  
  U8 nib;
  nib=n;

  nib&=0x0F;
  Lcd_write;
  PORTA = nib;
  Lcd_enable;
  PORTA = nib;
  Lcd_disable;


}


void write_lcd(U8 d)
{
  U8 dat;
  dat=d;

  dat=swap(dat);
  dat&=0x0F;
  Lcd_write;
  PORTA = dat;
  Lcd_enable;
  PORTA = dat;
  Lcd_disable;
  write_lcd_once(d);

}

void lcd_clear(void)
{

  Lcd_order;
  write_lcd(0b00000001);
  Lcd_data;

}

void lcd_init(void)
{

  _delay_ms(40);
  Lcd_order;
  write_lcd_once(0x03);
  _delay_us(37);
   write_lcd(0x28);
  _delay_us(37);
   write_lcd(0x28);
  _delay_us(37);
   write_lcd(0x0F);
  _delay_us(40);
   write_lcd(0x01);
  _delay_ms(1.52);
   write_lcd(0x06);
  _delay_us(37);


}

void cursor_home(void)
{
  Lcd_order;
  write_lcd(0b00000010);
  Lcd_data;

}






